/* $Id: CharClock.c,v 1.4 2000/12/08 21:48:07 tshiozak Exp $ */

#include <stdlib.h>
#include <string.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xmu/Drawing.h>

#include <CharClock/CharClockP.h>

static XtActionsRec actions[] = {
};

#define OffOf(f) XtOffsetOf(CharClockRec,f)

static XtResource resources[] = {
    { XtNclockTime1, XtCClockTime1, XtRString, sizeof(String),
      OffOf(charclock.time1), XtRString, "" },
    { XtNclockTime2, XtCClockTime2, XtRString, sizeof(String),
      OffOf(charclock.time2), XtRString, "" },
    { XtNclockAm, XtCClockAm, XtRString, sizeof(String),
      OffOf(charclock.am), XtRString, "" },
    { XtNclockPm, XtCClockPm, XtRString, sizeof(String),
      OffOf(charclock.pm), XtRString, "" },
    { XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel),
      OffOf(charclock.fore), XtRString, XtDefaultForeground },
    { XtNclockBiTmap1, XtCPixmap, XtRString, sizeof(String),
      OffOf(charclock.p.bitmap1.file), XtRString, "" },
    { XtNclockEpBiTmap01, XtCPixmap, XtRString, sizeof(String),
      OffOf(charclock.p.ep_bitmap1.file), XtRString, "" },
    { XtNclockEpBiTmap02, XtCPixmap, XtRString, sizeof(String),
      OffOf(charclock.p.ep_bitmap2.file), XtRString, "" },
    { XtNclockEpX, XtCClockEpX, XtRInt, sizeof(int),
      OffOf(charclock.ep_x), XtRString, "0" },
    { XtNclockEpY, XtCClockEpY, XtRInt, sizeof(int),
      OffOf(charclock.ep_y), XtRString, "0" },
    { XtNclockEpClosedTime, XtCClockEpClosedTime, XtRInt, sizeof(int),
      OffOf(charclock.ep_closed_time), XtRString, "2" },
    { XtNclockEpIntervalMin, XtCClockEpIntervalMin, XtRInt, sizeof(int),
      OffOf(charclock.ep_interval_min), XtRString, "40" },
    { XtNclockEpIntervalMax, XtCClockEpIntervalMax, XtRInt, sizeof(int),
      OffOf(charclock.ep_interval_max), XtRString, "101" },
    { XtNclockTimePeriod, XtCClockTimePeriod, XtRInt, sizeof(int),
      OffOf(charclock.time_period), XtRString, "10" },
    { XtNhTopLeftX, XtCHTopLeftX, XtRInt, sizeof(int),
      OffOf(charclock.h_top_left_x), XtRString, "0" },
    { XtNhTopLeftY, XtCHTopLeftY, XtRInt, sizeof(int),
      OffOf(charclock.h_top_left_y), XtRString, "0" },
    { XtNerExtentX, XtCErExtentX, XtRInt, sizeof(int),
      OffOf(charclock.er_extent_x), XtRString, "0" },
    { XtNerExtentY, XtCErExtentY, XtRInt, sizeof(int),
      OffOf(charclock.er_extent_y), XtRString, "0" },
    { XtNmsLeftXplus, XtCMsLeftXplus, XtRInt, sizeof(int),
      OffOf(charclock.ms_left_x_plus), XtRString, "0" },
    { XtNmsLeftYplus, XtCMsLeftYplus, XtRInt, sizeof(int),
      OffOf(charclock.ms_left_y_plus), XtRString, "0" },
    { XtNfontSet, XtCFontSet, XtRFontSet, sizeof(XFontSet),
      OffOf(charclock.fontset), XtRString, XtDefaultFontSet },
};

static char translations[] = "";

static void Initialize(), Realize(), Destroy(), Redisplay();
static Boolean SetValues();

CharClockClassRec charClockClassRec = {
    { /* core fields */
    /* superclass               */      (WidgetClass) &simpleClassRec,
    /* class_name               */      "CharClock",
    /* widget_size              */      sizeof(CharClockRec),
    /* class_initialize         */      XawInitializeWidgetSet,
    /* class_part_initialize    */      NULL,
    /* class_inited             */      FALSE,
    /* initialize               */      Initialize,
    /* initialize_hook          */      NULL,
    /* realize                  */      Realize,
    /* actions                  */      actions,
    /* num_actions              */      XtNumber(actions),
    /* resources                */      resources,
    /* resource_count           */      XtNumber(resources),
    /* xrm_class                */      NULLQUARK,
    /* compress_motion          */      TRUE,
    /* compress_exposure        */      TRUE,
    /* compress_enterleave      */      TRUE,
    /* visible_interest         */      FALSE,
    /* destroy                  */      Destroy,
    /* resize                   */      NULL,
    /* expose                   */      Redisplay,
    /* set_values               */      SetValues,
    /* set_values_hook          */      NULL,
    /* set_values_almost        */      XtInheritSetValuesAlmost,
    /* get_values_hook          */      NULL,
    /* accept_focus             */      NULL,
    /* version                  */      XtVersion,
    /* callback_private         */      NULL,
    /* tm_table                 */      translations,
    /* query_geometry           */      XtInheritQueryGeometry,
    /* display_accelerator      */      XtInheritDisplayAccelerator,
    /* extension                */      NULL
    },
    { /* simple fields */
    /* change_sensitive         */      XtInheritChangeSensitive
    },
    { /* charclock fields */
    /* dummy                    */      0
    }
};

WidgetClass charClockWidgetClass = (WidgetClass) &charClockClassRec;


static void
get_size_from_bitmap(char *file, int *width, int *height)
{
    unsigned char *data;

    XReadBitmapFileData(file, width, height, &data, NULL, NULL);
    XFree(data);
}

static void
read_pixmap(CharClockWidget w, struct _bitmap *bmp)
{
    unsigned char *data;
    int dum;

    bmp->pixmap=None;
    if (XReadBitmapFileData(bmp->file, &bmp->width, &bmp->height,
                            &data, &dum, &dum)) {
        fprintf(stderr, "read %s failed.\n", bmp->file);
        return;
    }
    bmp->pixmap=
        XCreatePixmapFromBitmapData(XtDisplay(w), XtWindow(w),
                                    data, bmp->width, bmp->height,
                                    w->charclock.fore,
                                    w->core.background_pixel,
                                    w->core.depth);
    XFree(data);
}

static void
Initialize(Widget request, Widget new, ArgList args, Cardinal *nargs)
{
    CharClockWidget w = (CharClockWidget) new;

    /* set widget extents forcibly */
    if (w->core.width<=0 || w->core.height<=0) {
        int width, height;
        get_size_from_bitmap(w->charclock.p.bitmap1.file,
                             &width, &height);
        w->core.width=width;
        w->core.height=height;
    }
        
    if (w->core.width<=0) w->core.width=1;
    if (w->core.height<=0) w->core.height=1;

    w->charclock.p.interval_id = (XtIntervalId)0;
    w->charclock.p.eye_state = EyeOpen;
    w->charclock.p.eyetimer_remain = 1;
    srand(10); /* XXX */
}

static void
draw_bg(CharClockWidget w)
{
    XClearWindow(XtDisplay(w), XtWindow(w));
    XSetFunction(XtDisplay(w), w->charclock.p.gc, GXcopy);
    XCopyArea(XtDisplay(w), w->charclock.p.bitmap1.pixmap,
              XtWindow(w), w->charclock.p.gc, 0, 0,
              w->charclock.p.bitmap1.width, w->charclock.p.bitmap1.height,
              0, 0);
}

static void
draw_string(CharClockWidget w, int x, int y, char *mb)
{
    int len;
    XFontSetExtents *ext = XExtentsOfFontSet(w->charclock.fontset);
    
    len=strlen(mb);
    XmbDrawString(XtDisplay(w), XtWindow(w), w->charclock.fontset,
                  w->charclock.p.gc, x, y+ext->max_ink_extent.height, mb, len);
}

static void
convert_format(CharClockWidget w, char *in, char *out, struct tm *t)
{
    int flag = 0;
    /* XXX: it has possibility of the buffer overrun */
    /* XXX: is is not sufficient for the 7bit unit coding system */
    while (*in) {
        if (flag) {
            flag=0;
            switch (*in) {
            case 'p': /* AM/PM */
                if (t->tm_hour>11) {
                    strcpy(out, w->charclock.pm);
                } else {
                    strcpy(out, w->charclock.am);
                }
                break;
            case 'I': /* hour [1-12] */
                sprintf(out, "%d", t->tm_hour%12 + (!(t->tm_hour%12)?12:0));
                break;
            case 'M': /* minutes */
                sprintf(out, "%d", t->tm_min);
                break;
            case 'S': /* minutes */
                sprintf(out, "%d", t->tm_sec);
                break;
            default:
                *out='\0';
            }
            out+=strlen(out);
        } else {
            if (*in=='%')
                flag=1;
            else {
                *out++=*in;
            }
        }
        in++;
    }
    *out='\0';
}

static void
draw_time(CharClockWidget w, struct tm *t)
{
    char buf[256]; /* XXX */
    XSetForeground(XtDisplay(w), w->charclock.p.gc,
                   w->core.background_pixel);
    XFillRectangle(XtDisplay(w), XtWindow(w), w->charclock.p.gc,
                   w->charclock.h_top_left_x, w->charclock.h_top_left_y-12,
                   w->charclock.er_extent_x, w->charclock.er_extent_y);
    XSetForeground(XtDisplay(w), w->charclock.p.gc, w->charclock.fore);
    /* 1 */
    convert_format(w, w->charclock.time1, buf, t);
    draw_string(w, w->charclock.h_top_left_x,
                w->charclock.h_top_left_y-12, buf);
    /* 2 */
    convert_format(w, w->charclock.time2, buf, t);
    draw_string(w, w->charclock.h_top_left_x+w->charclock.ms_left_x_plus,
                w->charclock.h_top_left_y+w->charclock.ms_left_y_plus-12,
                buf);
}

static void
get_gc(CharClockWidget w)
{
    /* create new gc */
    XGCValues values;

    values.function = GXcopy;
    values.foreground = w->charclock.fore;
    values.background = w->core.background_pixel;
    values.graphics_exposures = False;
    values.font = None;
    w->charclock.p.gc =
        XtAllocateGC(
            (Widget)w, 0,
            (XtGCMask)
            GCBackground | GCFunction | GCGraphicsExposures,
            &values, GCForeground | GCFont, 0 );
}

static void
tick(XtPointer client_data, XtIntervalId *id)
{
    CharClockWidget w = (CharClockWidget)client_data;
    time_t cur;
    struct tm *t;

    if (--w->charclock.p.eyetimer_remain<=0) {
        switch (w->charclock.p.eye_state) {
        case EyeOpen:
            /* to close */
            XCopyArea(XtDisplay(w), w->charclock.p.ep_bitmap2.pixmap,
                      XtWindow(w), w->charclock.p.gc, 0, 0,
                      w->charclock.p.ep_bitmap2.width,
                      w->charclock.p.ep_bitmap2.height,
                      w->charclock.ep_x,
                      w->charclock.ep_y-12);
            w->charclock.p.eyetimer_remain = w->charclock.ep_closed_time;
            w->charclock.p.eye_state = EyeClose;
            break;
        case EyeClose:
            /* to open */
            XCopyArea(XtDisplay(w), w->charclock.p.ep_bitmap1.pixmap,
                      XtWindow(w), w->charclock.p.gc, 0, 0,
                      w->charclock.p.ep_bitmap1.width,
                      w->charclock.p.ep_bitmap1.height,
                      w->charclock.ep_x,
                      w->charclock.ep_y-12);
            w->charclock.p.eyetimer_remain =
                (rand()%(w->charclock.ep_interval_max-
                         w->charclock.ep_interval_min))+
                w->charclock.ep_interval_min;
            w->charclock.p.eye_state = EyeOpen;
            break;
        }
    }
    time(&cur);
    if (memcmp(&cur, &w->charclock.p.time_prev, sizeof(cur))) {
        memcpy(&w->charclock.p.time_prev, &cur, sizeof(cur));
        t=localtime(&cur);
        draw_time(w, t);
    }
    w->charclock.p.interval_id =
        XtAppAddTimeOut(XtWidgetToApplicationContext((Widget) w),
                        w->charclock.time_period*10, tick, client_data);
}

static void
Realize(Widget gw, XtValueMask *mask, XSetWindowAttributes *attr)
{
    CharClockWidget w = (CharClockWidget)gw;

    *mask |= CWBitGravity;
    attr->bit_gravity = ForgetGravity;
    
    (*charClockWidgetClass->core_class.superclass->core_class.realize)
        (gw, mask, attr);

    read_pixmap(w, &w->charclock.p.bitmap1);
    read_pixmap(w, &w->charclock.p.ep_bitmap1);
    read_pixmap(w, &w->charclock.p.ep_bitmap2);
    get_gc(w);

    w->charclock.p.interval_id =
        XtAppAddTimeOut(XtWidgetToApplicationContext((Widget) w),
                        w->charclock.time_period*10, tick, (XtPointer)w);
}

static void
Destroy()
{
    /* XXX */
}

static void
Redisplay(Widget gw, XEvent *ev, Region reg)
{
    CharClockWidget w=(CharClockWidget)gw;
    time_t cur;
    struct tm *t;
   
    XSetWindowBackground(XtDisplay(w), XtWindow(w), w->core.background_pixel);
    draw_bg(w);
    time(&cur);
    memcpy(&w->charclock.p.time_prev, &cur, sizeof(cur));
    t=localtime(&cur);
    draw_time(w, t);
}

static Boolean
SetValues(Widget gcur, Widget greq, Widget gnew, ArgList args, Cardinal *nargs)
{
    CharClockWidget cur = (CharClockWidget) gcur;
    CharClockWidget new = (CharClockWidget) gnew;
    Boolean redisplay = FALSE;

    if (cur->charclock.fore != new->charclock.fore ||
        cur->core.background_pixel != new->core.background_pixel) {
        XtReleaseGC(gcur, cur->charclock.p.gc);
        get_gc(new);
        redisplay = TRUE;
    }

    return redisplay;
}


/* end of file */
