/* $Id: CharClockP.h,v 1.4 2000/12/08 21:48:07 tshiozak Exp $ */

#ifndef _CharClockP_h
#define _CharClockP_h

#include <time.h>

#include <CharClock/CharClock.h>
#include <X11/Xaw/SimpleP.h>


typedef struct _CharClockPart {
    /* resource fields */
    Pixel fore;
    String about;
    String time1, time2;
    String am, pm;
    int ep_x, ep_y;
    int ep_closed_time, ep_interval_min, ep_interval_max, time_period;
    int h_top_left_x, h_top_left_y;
    int er_extent_x, er_extent_y;
    int ms_left_x_plus, ms_left_y_plus;
    XFontSet fontset;
    /* private datas */
    struct {
        GC gc;
        struct _bitmap {
            String file;
            Pixmap pixmap; /* full depth */
            unsigned int width, height;
        } bitmap1, ep_bitmap1, ep_bitmap2;
        XtIntervalId interval_id;
        enum { EyeOpen, EyeClose } eye_state;
        int eyetimer_remain;
        time_t time_prev;
    } p;
} CharClockPart;

typedef struct _CharClockRec {
    CorePart core;
    SimplePart simple;
    CharClockPart charclock;
} CharClockRec;

typedef struct _CharClockClassPart {
    int dummy;
} CharClockClassPart;

typedef struct _CharClockClassRec {
    CoreClassPart core_class;
    SimpleClassPart simple_class;
    CharClockClassPart charclock_class;
} CharClockClassRec;

extern CharClockClassRec charClockClassRec;


#endif

/* end of file */
