/* $Id: xccda.c,v 1.3 2000/12/08 20:34:07 tshiozak Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>
#include <CharClock/CharClock.h>

static Atom wm_delete_window;

static void
Quit(Widget w, XEvent *ev, String *params, Cardinal *nparams)
{
    if (ev->type==ClientMessage && ev->xclient.data.l[0] == wm_delete_window) {
        XCloseDisplay(XtDisplay(w));
        exit(0);
    }
}

static XtActionsRec actions[] = {
    { "quit", Quit },
};

static XrmOptionDescRec options[] = {
    { "-fg", "*Foreground", XrmoptionSepArg, NULL },
};

static String fallbacks[] = {
    "Xccda.translations: #override\\n<Message>WM_PROTOCOLS: quit()\\n",
    NULL
};


int
main(int ac, char **av)
{
    XtAppContext app_context;
    Widget toplevel, clock;

    XtSetLanguageProc(NULL, NULL, NULL);

    toplevel = XtVaOpenApplication(&app_context, "Xccda",
                                   options, XtNumber(options),
                                   &ac, av, fallbacks,
                                   applicationShellWidgetClass,
                                   NULL);
    XtAppAddActions(app_context, actions, XtNumber(actions));
    clock =
        XtVaCreateManagedWidget(
            "clock", charClockWidgetClass, toplevel,
            NULL);
    XtRealizeWidget(toplevel);
    wm_delete_window =
        XInternAtom(XtDisplay(toplevel), "WM_DELETE_WINDOW", False);
    XSetWMProtocols(XtDisplay(toplevel), XtWindow(toplevel),
                    &wm_delete_window, 1);
    XtAppMainLoop(app_context);

    return 0;
}
